VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RsPrinter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' A class to Print Recordset (ADO DAO)
' Author: Opal Raj Ghimire, buna48@hotmail.com
'------------------------------------------
' You are free to use this class in your
' projects.
' This project comes with absolutely NO
' warranty ! Use it at your own risk !
' May posses errors !!


Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function RoundRect Lib "gdi32" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long) As Long
Private Declare Function LineTo Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal Y As Long) As Long
Private Declare Function MoveToEx Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal Y As Long, lpPoint As POINTAPI) As Long
  
Private BorX As Long, BorY As Long
Private BorDX As Long, BorDY As Long  ' Bor=Boarder
Private bFieldPrinted As Boolean              ' Fields Names printed or not
Private RecSource As Object                   ' Rocordset object
Private Cols() As String                             ' Col width
Private Aligns() As String                           ' Alignments
Private bFPage As Boolean                       ' Final page flag

Private Type POINTAPI
        x As Long
        Y As Long
End Type

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type
'********************Publics*************************

Public PosTop As Long: Public PosLeft As Long
Public VSpace As Long: Public HSpace As Long
Public GridPrint As Boolean: Public GridColor As Long: Public GridStyle As Long: Public GridWidth As Long
Public HorLines As Boolean 'Prints a line between the rows
Public VerLines As Boolean 'Prints a line between cols
Public RowsPerPage As Integer: Public RowHeight As Long
Public BoarderPrint As Boolean: Public BoarderWidth As Long: Public BoarderColor As Long
Public BoarderDistance As Long: Public BoarderStyle As Long
Public WordWrap As Boolean
Public RoundX As Long: Public RoundY As Long
Public FillColor As Long: Public TextColor As Long
Public CurX As Long: Public CurY As Long

'*************Const****************
Const DT_LEFT = 0
Const DT_CENTER = 1
Const DT_RIGHT = 2
Const DT_VCENTER = 4
Const DT_WORDBREAK = 16
Const DT_SINGLELINE = 32
Const DT_NOPREFIX = 2048
Const DT_END_ELLIPSIS = 32768
Const DT_MODIFYSTRING = 65536
Const DT_WORD_ELLIPSIS = 262144
Const DT_RTLREADING = 131072  'For RightToLeft people

Private Sub Class_Initialize()
'********Default Values*************
PosTop = 50: PosLeft = 50: VSpace = 5: HSpace = 5
GridPrint = True: GridColor = vbBlack: GridStyle = 0: GridWidth = 1
RowsPerPage = 10: RowHeight = 250
BoarderPrint = True: BoarderWidth = 1: BoarderColor = vbBlack: BoarderDistance = 5: BoarderStyle = 0
Cols = Split("1000,1000,1500,1500", ",")
Aligns = Split("0,0,0,0", ",")
RoundX = 0: RoundY = 0: TextColor = vbBlack: FillColor = vbWhite
BorX = 0: BorY = 0
HorLines = False
VerLines = False
End Sub

Public Property Let ColWidthStr(NewValue As String)
Cols = Split(NewValue, ",")
End Property

Public Property Let ColAlignStr(NewValue As String)
Aligns = Split(NewValue, ",")
End Property

Public Sub PrintOut(obj As Object, ByVal PageNumber As Long)
On Error Resume Next
Dim Kount As Long, Num_of_Cols As Long
Dim Box As RECT, Rows As Long, sText As Variant
Dim Left As Long, Top As Long, RowHt As Long, Col As Long
Dim DT_Code As Long, MulX As Double, OldPen As Long, NewPen As Long
Dim OldBrush As Long, NewBrush As Long
Dim opal As POINTAPI, DT_Code2 As Long, BackUpPosTop As Long
Dim VLines() As Long
Dim WidthX As Long, HeightX As Long
Dim HalfBorDis As Long
Dim TmpW As Long, A As Long, bValueChanged As Boolean
'----------------------------------------------
'to avoid page # 0
PageNumber = PageNumber - 1: PageNumber = Abs(PageNumber)
If TypeName(RecSource) <> "Recordset" Then Exit Sub

obj.ScaleMode = vbPixels
obj.Print
MulX = 1 'MulX is multiplyer
If TypeName(obj) = "Printer" Then
             'following lines assumes printer's pixels always smaller than screen's
             MulX = Screen.TwipsPerPixelX / Printer.TwipsPerPixelX
             'While obj is printer MulX multiplys all draw width so that it looks like as in screen
             'if you want smaller drawwidth in printer use following line make sure to make same correction in PrintFileds, GetHeight and GetWidth methods
             'MulX = MulX / 2
End If  'TypeName(obj) = "Printer"

If HorLines Then WidthX = GetWidth(obj) 'Calculates width of picture

RowHt = obj.ScaleY(RowHeight, vbTwips, vbPixels)

'Getting Number of fields of recordset
Num_of_Cols = RecSource.Fields.Count - 1

If VerLines = True Then ReDim VLines(Num_of_Cols) ' HeightX = GetHeight(obj, bFieldPrinted)

'Setting default alignment
If WordWrap Then
        DT_Code = DT_LEFT Or DT_WORDBREAK Or DT_NOPREFIX Or DT_MODIFYSTRING Or DT_RTLREADING
Else
        DT_Code = DT_LEFT Or DT_SINGLELINE Or DT_NOPREFIX Or DT_MODIFYSTRING Or DT_VCENTER Or DT_RTLREADING
End If
'Reserving space for width of Box and for alignments
ReDim Preserve Cols(Num_of_Cols)
ReDim Preserve Aligns(Num_of_Cols)
'Putting 0 into empty ones
For Kount = 0 To UBound(Cols)
        If Cols(Kount) = Empty Then Cols(Kount) = "0"
        If Aligns(Kount) = Empty Then Aligns(Kount) = Str(DT_Code)
Next Kount

SetTextColor obj.hDC, TextColor

Left = PosLeft
Top = PosTop

'for Boarders
HalfBorDis = BoarderDistance / 2

If BoarderPrint Then
        Left = PosLeft + (HalfBorDis * MulX)
        Top = PosTop + (HalfBorDis * MulX)
        BorX = PosLeft
        BorY = PosTop
End If

If bFieldPrinted Then
        Top = PosTop + RowHt + ((VSpace - GridWidth) * MulX)
                If BoarderPrint Then Top = Top + (HalfBorDis * MulX)
        bFieldPrinted = False
End If

'Preparing the page
RecSource.MoveFirst
 If Err = 3021 Then
           'Either EOF or BOF
           'Handle this yourself
           MsgBox Err.Description
 End If
RecSource.Move RowsPerPage * PageNumber

If GridPrint Or HorLines Or VerLines Then   'Making Pen
            NewPen = CreatePen(GridStyle, GridWidth * MulX, GridColor)
            NewBrush = CreateSolidBrush(FillColor)
            OldPen = SelectObject(obj.hDC, NewPen)
            OldBrush = SelectObject(obj.hDC, NewBrush)
End If  'GridPrint Or HorLines

For Rows = 0 To RowsPerPage - 1
        For Col = 0 To Num_of_Cols
              With Box
                    .Left = Left
                    .Top = Top
                    .Right = .Left + obj.ScaleX(Val(Cols(Col)), vbTwips, vbPixels)
                    .Bottom = .Top + RowHt
              End With
              
               sText = ""
               If Not IsNull(RecSource.Fields(Col).Value) Then sText = RecSource.Fields(Col).Value
        
               If GridPrint Then RoundRect obj.hDC, Box.Left, Box.Top, Box.Right, Box.Bottom, obj.ScaleX(RoundX, vbTwips, vbPixels), obj.ScaleY(RoundY, vbTwips, vbPixels)
               If VerLines Then VLines(Col) = Box.Left
               Box.Top = Box.Top + (3 * MulX): Box.Right = Box.Right - (3 * MulX)
               Box.Left = Box.Left + (3 * MulX): Box.Bottom = Box.Bottom - (3 * MulX)
               DT_Code2 = DT_Code Or CLng(Aligns(Col))
        
               DrawText obj.hDC, sText, Len(sText), Box, DT_Code2
               
               DT_Code2 = 0
               Left = Left + obj.ScaleY(Val(Cols(Col)), vbTwips, vbPixels) + ((HSpace - GridWidth) * MulX)
               'Reduce the space in between columns
               If Val(Cols(Col)) = 0 Then Left = Left + obj.ScaleY(Val(Cols(Col)), vbTwips, vbPixels) - ((HSpace - GridWidth) * MulX)
        Next Col
    
    Top = Top + RowHt + ((VSpace - GridWidth) * MulX)
    Left = PosLeft
    If BoarderPrint Then Left = Left + (HalfBorDis * MulX)
    RecSource.MoveNext
        
    If HorLines Then  'Block to print Horizontle lines
            If Rows <> RowsPerPage - 1 Then   'This if prevents the last line form being printed
                         Kount = ((VSpace - GridWidth) / 2) * MulX
                         MoveToEx obj.hDC, PosLeft, Top - Kount, opal
                         LineTo obj.hDC, (PosLeft + WidthX), Top - Kount
            End If  ' This if prevents the ....
    End If  'Horizontle lines
          
    bFPage = False  'bFPage  Final Page indicator
    
    If Err = 3021 Then
            bFPage = True
            'HeightX = Box.Bottom - PosTop + (HalfBorDis * MulX)
            Exit For
    End If
Next Rows

If VerLines Then 'To print Vertical lines betn rows
        TmpW = ((HSpace - GridWidth) / 2) * MulX
        A = UBound(Cols)
        For Kount = A To 0 Step -1  ' if last colwidth=0 then remove that
            If Val(Cols(Kount)) <> 0 Then Exit For
        Next
        
        If Kount <> A Then ReDim Preserve VLines(Kount)
        
        For Kount = 1 To UBound(VLines) ' Drawing the lines
            If VLines(Kount) <> 0 Then
                MoveToEx obj.hDC, VLines(Kount) - TmpW, PosTop, opal
                LineTo obj.hDC, VLines(Kount) - TmpW, Box.Bottom + (HalfBorDis * MulX) + (3 * MulX) 'HeightX + PosTop
                
            End If 'VLines(Kount) <> 0
        Next

End If  'VerLines


If GridPrint Or HorLines Or VerLines Then  'Killing Pen
                         SelectObject obj.hDC, OldPen: SelectObject obj.hDC, OldBrush
                         DeleteObject NewPen: DeleteObject NewBrush
                    
End If  'GridPrint Or HorLines

If Val(Cols(UBound(Cols))) = 0 Then Box.Right = Box.Right - ((HSpace - GridWidth) * MulX)

Box.Bottom = Box.Bottom + (3 * MulX)
Box.Right = Box.Right + (3 * MulX)
BorDX = Box.Right + (HalfBorDis * MulX)
BorDY = Box.Bottom + (HalfBorDis * MulX)

CurX = Box.Right: CurY = Box.Bottom

If BoarderPrint Then
        CurX = BorDX
        CurY = BorDY
        
        NewPen = CreatePen(BoarderStyle, BoarderWidth * MulX, BoarderColor)
        OldPen = SelectObject(obj.hDC, NewPen)

        MoveToEx obj.hDC, BorDX, BorDY, opal  'Starting point Dx Dy
        LineTo obj.hDC, BorX, BorDY         'MoveRight
        LineTo obj.hDC, BorX, BorY            'MoveUp
        LineTo obj.hDC, BorDX, BorY          'Moveleft
        LineTo obj.hDC, BorDX, BorDY       'MoveDown to starting point
       
        SelectObject obj.hDC, OldPen
        DeleteObject NewPen

End If  'BoarderPrint


End Sub

Public Property Set RowSource(ByVal vNewValue As Object)
'RowSource is ADO or DAO recordset object
Set RecSource = vNewValue
End Property

Private Sub Class_Terminate()
Set RecSource = Nothing
End Sub

Public Sub PrintFields(obj As Object)
Dim Kount As Long, Num_of_Cols As Long
Dim Box As RECT, sText As String
Dim Left As Long, Top As Long, RowHt As Long, Col As Long
Dim DT_Code As Long, Mul As Double, OldPen As Long, NewPen As Long
Dim OldBrush As Long, NewBrush As Long, opal As POINTAPI
Dim WidthX As Long
Dim DT_Code2 As Long
Dim HalfBorDis As Long

'--------------------------------------

If TypeName(RecSource) <> "Recordset" Then Exit Sub
Mul = 1
'Mul is multiplyer
obj.ScaleMode = vbPixels
obj.Print
If TypeName(obj) = "Printer" Then
        'following lines assumes printer's resolution always smaller than screen
        Mul = Screen.TwipsPerPixelX / Printer.TwipsPerPixelX
        'While obj is printer Mul multiplys all draw width so that it looks like as in screen
        'if you want smaller drawwidth in printer use following line
        'make sure to make same correction in PrintOut , GetHeight and GetWidth methods
        'Mul = Mul / 2

End If  'TypeName(obj) = "Printer"

Left = PosLeft
Top = PosTop
HalfBorDis = BoarderDistance / 2

If BoarderPrint Then
        BorX = PosLeft
        BorY = PosTop
        Left = PosLeft + (HalfBorDis * Mul)
        Top = PosTop + (HalfBorDis * Mul)
End If

RowHt = obj.ScaleY(RowHeight, vbTwips, vbPixels)

'Getting Number of fields of recordset
Num_of_Cols = RecSource.Fields.Count - 1
'Setting default alignment
If WordWrap Then
        DT_Code = DT_LEFT Or DT_WORDBREAK Or DT_NOPREFIX Or DT_MODIFYSTRING Or DT_RTLREADING
Else
        DT_Code = DT_LEFT Or DT_SINGLELINE Or DT_NOPREFIX Or DT_MODIFYSTRING Or DT_VCENTER Or DT_RTLREADING
End If

'Reserving space for width of Box and for alignments
ReDim Preserve Cols(Num_of_Cols)
ReDim Preserve Aligns(Num_of_Cols)

'Putting 0 into empty ones
For Kount = 0 To UBound(Cols)
        If Cols(Kount) = Empty Then Cols(Kount) = "0"
        If Aligns(Kount) = Empty Then Aligns(Kount) = Str(DT_Code)
Next Kount

SetTextColor obj.hDC, TextColor

If GridPrint Or HorLines Then
             NewPen = CreatePen(GridStyle, GridWidth * Mul, GridColor)
             NewBrush = CreateSolidBrush(FillColor)
             OldPen = SelectObject(obj.hDC, NewPen)
             OldBrush = SelectObject(obj.hDC, NewBrush)
End If  'GridPrint or HorLines

For Kount = 0 To RecSource.Fields.Count - 1
    sText = RecSource.Fields(Kount).Name
    With Box
            .Left = Left
            .Top = Top
            .Right = .Left + obj.ScaleX(Val(Cols(Kount)), vbTwips, vbPixels)
            .Bottom = .Top + RowHt
    End With

    If GridPrint Then RoundRect obj.hDC, Box.Left, Box.Top, Box.Right, Box.Bottom, obj.ScaleX(RoundX, vbTwips, vbPixels), obj.ScaleY(RoundY, vbTwips, vbPixels)
    
    Box.Top = Box.Top + (3 * Mul): Box.Right = Box.Right - (3 * Mul)
    Box.Left = Box.Left + (3 * Mul): Box.Bottom = Box.Bottom - (3 * Mul)
    DT_Code2 = DT_Code Or Val(Aligns(Kount))
    DrawText obj.hDC, sText, Len(sText), Box, DT_Code2
    DT_Code2 = 0: sText = ""
    Left = Left + obj.ScaleY(Val(Cols(Kount)), vbTwips, vbPixels) + ((HSpace - GridWidth) * Mul)
    'Reduce the space in between columns if cols width=0
    If Val(Cols(Kount)) = 0 Then Left = Left + obj.ScaleY(Val(Cols(Kount)), vbTwips, vbPixels) - ((HSpace - GridWidth) * Mul)
   
Next Kount

If HorLines Then
             Kount = ((VSpace - GridWidth) / 2) * Mul
             WidthX = GetWidth(obj)
             MoveToEx obj.hDC, PosLeft, Top + RowHt + Kount, opal
             LineTo obj.hDC, (PosLeft + WidthX), Top + RowHt + Kount
End If  'HorLines
         
If GridPrint Or HorLines Then
             SelectObject obj.hDC, OldPen: SelectObject obj.hDC, OldBrush
             DeleteObject NewPen: DeleteObject NewBrush
End If  'GridPrint
   
bFieldPrinted = True
End Sub

Public Property Get FinalPage() As Boolean
'Flag to indicate Last page is displayed or Printed
FinalPage = bFPage
End Property

'Returns width of output in PIXELS
Public Property Get GetWidth(obj As Object) As Long
Dim Kount As Long, Mul As Double
Dim TotWidth As Long
Dim TotHSpace As Long, ToT As Long
Dim TotZeroCol As Long
Dim TotCols As Long
Mul = 1
obj.ScaleMode = vbPixels
obj.Print
If TypeName(obj) = "Printer" Then Mul = Screen.TwipsPerPixelX / Printer.TwipsPerPixelX
TotCols = UBound(Cols)
For Kount = 0 To TotCols
        TotWidth = TotWidth + obj.ScaleX(Val(Cols(Kount)), vbTwips, vbPixels)
        If Val(Cols(Kount)) = 0 Then TotZeroCol = TotZeroCol + 1
Next Kount
ToT = TotCols - TotZeroCol
TotHSpace = ToT * ((HSpace * Mul) - (GridWidth * Mul))

GetWidth = TotWidth + TotHSpace

If BoarderPrint Then GetWidth = GetWidth + (BoarderDistance * Mul)
End Property

'Returns height of output in PIXELS
Public Property Get GetHeight(obj As Object, Including_FieldNames As Boolean) As Long
Dim RHeight As Single, Mul As Double
Dim ToTHeight As Long, TotVspace As Long
Dim Num_of_Rows As Long
Num_of_Rows = RowsPerPage
Mul = 1
obj.ScaleMode = vbPixels
obj.Print
If TypeName(obj) = "Printer" Then Mul = Screen.TwipsPerPixelY / Printer.TwipsPerPixelY

If Including_FieldNames Then Num_of_Rows = Num_of_Rows + 1

RHeight = obj.ScaleY(RowHeight, vbTwips, vbPixels) + ((VSpace * Mul) - (GridWidth * Mul))
ToTHeight = (RHeight * Num_of_Rows) - ((VSpace * Mul) - (GridWidth * Mul))

If BoarderPrint Then ToTHeight = ToTHeight + (BoarderDistance * Mul)
GetHeight = ToTHeight
End Property

